/******************************************************************************/
/*                                                                            */
/*                           P C I - B I O S   V1.12c                         */
/*                                                                            */
/*                        PCI-BIOS for ATARI-Compatibles                      */
/*                                                                            */
/*  Module:        PCI-BIOS (PCI_BIOS.PRG)                                    */
/*  File:          PCI_BIOS.H                                                 */
/*  Description:   general declarations for the usage of the ATARI PCI-BIOS   */
/*                                                                            */
/*  (c)1997/1998 Markus Fichtenbauer                              13.09.1998  */
/*                                                                            */
/******************************************************************************/
/* $Id$ */
/******************************************************************************/
/* $Log$ */
/******************************************************************************/

#if !defined( __PCIBIOS__ )
  #define __PCIBIOS__

/******************************************************************************/
/*                         PCI-BIOS function prototypes                       */
/******************************************************************************/
  extern LONG pcibios_init(void);

/******************************************************************************/
/*                          PCI-BIOS function pointers                        */
/******************************************************************************/
  LONG (*find_pci_device)(ULONG id, UWORD index) = NULL;
  LONG (*find_pci_classcode)(ULONG class, UWORD index) = NULL;
  LONG (*read_config_byte)(LONG handle, UBYTE reg, UBYTE *adresse) = NULL;
  LONG (*read_config_word)(LONG handle, UBYTE reg, UWORD *adresse) = NULL;
  LONG (*read_config_longword)(LONG handle, UBYTE reg, ULONG *adresse) = NULL;
  UBYTE (*fast_read_config_byte)(LONG handle, UBYTE reg) = NULL;
  UWORD (*fast_read_config_word)(LONG handle, UBYTE reg) = NULL;
  ULONG (*fast_read_config_longword)(LONG handle, UBYTE reg) = NULL;
  LONG (*write_config_byte)(LONG handle, UBYTE reg, UBYTE val) = NULL;
  LONG (*write_config_word)(LONG handle, UBYTE reg, UWORD val) = NULL;
  LONG (*write_config_longword)(LONG handle, UBYTE reg, ULONG val) = NULL;
  LONG (*hook_interrupt)(LONG handle, ULONG *routine, ULONG *parameter) = NULL;
  LONG (*unhook_interrupt)(LONG handle) = NULL;
  LONG (*special_cycle)(UBYTE bus, ULONG data) = NULL;
  LONG (*get_routing)(LONG handle) = NULL;
  LONG (*set_interrupt)(LONG handle) = NULL;
  LONG (*get_resource)(LONG handle) = NULL;
  LONG (*get_card_used)(LONG handle, ULONG *adresse) = NULL;
  LONG (*set_card_used)(LONG handle, ULONG *callback) = NULL;
  LONG (*read_mem_byte)(LONG handle, ULONG offset, UBYTE *adresse) = NULL;
  LONG (*read_mem_word)(LONG handle, ULONG offset, UWORD *adresse) = NULL;
  LONG (*read_mem_longword)(LONG handle, ULONG offset, ULONG *adresse) = NULL;
  UBYTE (*fast_read_mem_byte)(LONG handle, ULONG offset) = NULL;
  UWORD (*fast_read_mem_word)(LONG handle, ULONG offset) = NULL;
  ULONG (*fast_read_mem_longword)(LONG handle, ULONG offset) = NULL;
  LONG (*write_mem_byte)(LONG handle, ULONG offset, UBYTE val) = NULL;
  LONG (*write_mem_word)(LONG handle, ULONG offset, UWORD val) = NULL;
  LONG (*write_mem_longword)(LONG handle, ULONG offset, ULONG val) = NULL;
  LONG (*read_io_byte)(LONG handle, ULONG offset, UBYTE *adresse) = NULL;
  LONG (*read_io_word)(LONG handle, ULONG offset, UWORD *adresse) = NULL;
  LONG (*read_io_longword)(LONG handle, ULONG offset, ULONG *adresse) = NULL;
  UBYTE (*fast_read_io_byte)(LONG handle, ULONG offset) = NULL;
  UWORD (*fast_read_io_word)(LONG handle, ULONG offset) = NULL;
  ULONG (*fast_read_io_longword)(LONG handle, ULONG offset) = NULL;
  LONG (*write_io_byte)(LONG handle, ULONG offset, UBYTE val) = NULL;
  LONG (*write_io_word)(LONG handle, ULONG offset, UWORD val) = NULL;
  LONG (*write_io_longword)(LONG handle, ULONG offset, ULONG val) = NULL;
  LONG (*get_machine_id)(void) = NULL;
  LONG (*get_pagesize)(void) = NULL;
  LONG (*virt_to_bus)(LONG handle, ULONG adresse, ULONG *pointer) = NULL;
  LONG (*bus_to_virt)(LONG handle, ULONG adresse, ULONG *pointer) = NULL;
  LONG (*virt_to_phys)(ULONG adresse, ULONG *pointer) = NULL;
  LONG (*phys_to_virt)(ULONG adresse, ULONG *pointer) = NULL;

#else                                  /* __PCIBIOS__                         */
  #error "PCI-BIOS functions already defined as external procedures"
#endif                                 /* __PCIBIOS__                         */

